CREATE TABLE data_point (
	_id INTEGER PRIMARY KEY AUTOINCREMENT,

	data_type TEXT NOT NULL,
	end_datetime REAL NOT NULL,
	start_datetime REAL,
	fields BLOB NOT NULL -- JSON representation of the values dictionary in the data point
);
CREATE INDEX idx_data_points_datetime ON data_point(end_datetime, start_datetime);
CREATE INDEX idx_data_points_type ON data_point(data_type);

CREATE TABLE recorder_configuration (
	_id INTEGER PRIMARY KEY AUTOINCREMENT,

	name TEXT NOT NULL,
	archived_object BLOB NOT NULL -- NSKeyedArchiver representation of the configuration object graph
);
CREATE INDEX idx_recorder_configuration_name ON recorder_configuration(name);
