-- user
-- Table for User Entity
CREATE TABLE user_entity (
	_id INTEGER PRIMARY KEY AUTOINCREMENT, -- 0
        remote_id TEXT,
        first_name TEXT,
        last_name TEXT,
        display_name TEXT,
        last_initial TEXT,
        username TEXT,
        email TEXT,
        birthdate INTEGER,
        gender INTEGER, -- 0
        height INTEGER, -- 0
        weight INTEGER, -- 0
        last_login INTEGER,
        date_joined DATE,
        introduction TEXT,
        hobbies TEXT,
        goal_statement TEXT,
		profile_statement TEXT,
        display_measurement_system INTEGER,
        time_zone TEXT,
        promotions INTEGER,
        newsletter INTEGER,
        system_messages INTEGER,
        share_twitter INTEGER,
        share_facebook INTEGER,
        country TEXT,
        region TEXT,
        locality TEXT,
        address TEXT,
        privacy_profile INTEGER,
        privacy_workout INTEGER,
        privacy_activity_feed INTEGER,
        privacy_bodymass INTEGER,
        privacy_food_log INTEGER,
        privacy_email_search INTEGER,
        privacy_route INTEGER,
        privacy_sleep INTEGER
);
CREATE UNIQUE INDEX idx_user_entity_remote_id ON user_entity(remote_id);

-- autocomplete table
CREATE TABLE user_search (
	_id INTEGER PRIMARY KEY AUTOINCREMENT, -- 0
    search_term TEXT,
    filter TEXT,

	-- key to the resource
	entity_id INTEGER,
	FOREIGN KEY(entity_id) REFERENCES user_entity(_id) ON DELETE CASCADE
);
