#!/usr/local/perl

use strict;
use warnings;

use Getopt::Std;
my %opts;
my $voiceid;
my $voicedir;
my $voicerename;


getopts('i:d:r:', \%opts);

if ($opts{i}) {$voiceid=$opts{i};}
else {$voiceid="laura";}

if ($opts{d}) {$voicedir=$opts{d};}
else {$voicedir=$voiceid;}

if ($opts{r}) {$voicerename=$opts{r};}
else {$voicerename ="";}


 

print "\n==========================================\n";
print "Checking for voice personality ".$voiceid." in ".$voicedir."\n";
print "==========================================\n";


my @files = ( '0.mp3'
          ,'1.mp3'
          ,'2.mp3'
          ,'3.mp3'
          ,'4.mp3'
          ,'5.mp3'
          ,'6.mp3'
          ,'7.mp3'
          ,'8.mp3'
          ,'9.mp3'
          ,'10.mp3'
          ,'11.mp3'
          ,'12.mp3'
          ,'13.mp3'
          ,'14.mp3'
          ,'15.mp3'
          ,'16.mp3'
          ,'17.mp3'
          ,'18.mp3'
          ,'19.mp3'
          ,'20.mp3'
          ,'21.mp3'
          ,'22.mp3'
          ,'23.mp3'
          ,'24.mp3'
          ,'25.mp3'
          ,'26.mp3'
          ,'27.mp3'
          ,'28.mp3'
          ,'29.mp3'
          ,'30.mp3'
          ,'31.mp3'
          ,'32.mp3'
          ,'33.mp3'
          ,'34.mp3'
          ,'35.mp3'
          ,'36.mp3'
          ,'37.mp3'
          ,'38.mp3'
          ,'39.mp3'
          ,'40.mp3'
          ,'41.mp3'
          ,'42.mp3'
          ,'43.mp3'
          ,'44.mp3'
          ,'45.mp3'
          ,'46.mp3'
          ,'47.mp3'
          ,'48.mp3'
          ,'49.mp3'
          ,'50.mp3'
          ,'51.mp3'
          ,'52.mp3'
          ,'53.mp3'
          ,'54.mp3'
          ,'55.mp3'
          ,'56.mp3'
          ,'57.mp3'
          ,'58.mp3'
          ,'59.mp3'
          ,'60.mp3'
          ,'61.mp3'
          ,'62.mp3'
          ,'63.mp3'
          ,'64.mp3'
          ,'65.mp3'
          ,'66.mp3'
          ,'67.mp3'
          ,'68.mp3'
          ,'69.mp3'
          ,'70.mp3'
          ,'71.mp3'
          ,'72.mp3'
          ,'73.mp3'
          ,'74.mp3'
          ,'75.mp3'
          ,'76.mp3'
          ,'77.mp3'
          ,'78.mp3'
          ,'79.mp3'
          ,'80.mp3'
          ,'81.mp3'
          ,'82.mp3'
          ,'83.mp3'
          ,'84.mp3'
          ,'85.mp3'
          ,'86.mp3'
          ,'87.mp3'
          ,'88.mp3'
          ,'89.mp3'
          ,'90.mp3'
          ,'91.mp3'
          ,'92.mp3'
          ,'93.mp3'
          ,'94.mp3'
          ,'95.mp3'
          ,'96.mp3'
          ,'97.mp3'
          ,'98.mp3'
          ,'99.mp3'
          ,'100.mp3'
          ,'200.mp3'
          ,'300.mp3'
          ,'400.mp3'
          ,'500.mp3'
          ,'600.mp3'
          ,'700.mp3'
          ,'800.mp3'
          ,'900.mp3'
           ,'1000.mp3'

           ,'ahead.mp3'
           ,'alot.mp3'
           ,'approachingcourse.mp3'
           ,'average.mp3'
           ,'averagecadence.mp3'
           ,'averageheartrate.mp3'
           ,'averagepace.mp3'
           ,'averagespeed.mp3'

           ,'beatsperminute.mp3'
           ,'behind.mp3'
           ,'cadence.mp3'
           ,'calorie.mp3'
           ,'calories.mp3'
           ,'caloriesburned.mp3'
           ,'comeon.mp3'
           ,'comma.mp3'
           ,'completedcourse.mp3'
           ,'congratulations.mp3'
           ,'congratulationsgreatjob.mp3'
           ,'congratulationsthatwasyourpersonalbest.mp3'
           ,'current.mp3'
           ,'currentcadence.mp3'
           ,'currentdistance.mp3'
           ,'currentpace.mp3'
           ,'currentpoweroutput.mp3'
           ,'currentspeed.mp3'

           ,'distance.mp3'
           ,'dontgiveup.mp3'
           ,'duration.mp3'

           ,'fast.mp3'
           ,'faster.mp3'

           ,'goalreached.mp3'
           ,'greatjob.mp3'

           ,'halfway.mp3'
           ,'heartrate.mp3'
           ,'highfive.mp3'
           ,'highintensity.mp3'
           ,'hour.mp3'
           ,'hours.mp3'
           ,'hundred.mp3'

           ,'ilikewhatyoudidthere.mp3'
           ,'interval.mp3'
           ,'intervalworkoutstartsnowwitha.mp3'

           ,'justalittlefurther.mp3'
           ,'justonemore.mp3'

           ,'kilometer.mp3'
           ,'kilometerperhour.mp3'
           ,'kilometers.mp3'
           ,'kilometersperhour.mp3'

           ,'lap.mp3'
           ,'lowintensity.mp3'

           ,'maxcadence.mp3'
           ,'maxheartrate.mp3'
           ,'maxpoweroutput.mp3'
           ,'medium.mp3'
           ,'mile.mp3'
           ,'mileperhour.mp3'
           ,'miles.mp3'
           ,'milesperhour.mp3'
           ,'mincadence.mp3'
           ,'minute.mp3'
           ,'minutes.mp3'
           ,'minutesperkilometer.mp3'
           ,'minutespermile.mp3'

           ,'nextinterval.mp3'
           ,'now.mp3'

           ,'onequarter.mp3'

           ,'pace.mp3'
           ,'perkilometer.mp3'
           ,'permile.mp3'
           ,'point.mp3'
           ,'power.mp3'
           ,'poweroutput.mp3'

           ,'sample.mp3'
           ,'slow.mp3'
           ,'speed.mp3'
           ,'splitpace.mp3'
           ,'startworkout.mp3'
           ,'second.mp3'
           ,'slowdown.mp3'
           ,'speedup.mp3'
           ,'splitspeed.mp3'
           ,'stepcount.mp3'
           ,'seconds.mp3'
           ,'slower.mp3'
           ,'split.mp3'
           ,'startsin.mp3'
           ,'steps.mp3'

           ,'target.mp3'
           ,'toofast.mp3'
           ,'targetdistance.mp3'
           ,'threequarters.mp3'
           ,'tooslow.mp3'
           ,'thatisalotofcalories.mp3'
           ,'time.mp3'
           ,'total.mp3'
           ,'thatwasa.mp3'
           ,'timetobeat.mp3'
           ,'totalcaloriesburned.mp3'
           ,'thecurrenttimeis.mp3'
           ,'timetocooldownfor.mp3'

,'warmup.mp3'
,'warmupfor.mp3'
,'watts.mp3'
,'workout.mp3'
,'wow.mp3'
,'wowiamimpressed.mp3'

,'yay.mp3'						
,'youhavereachedyourgoal.mp3'
,'youare.mp3'						
,'youareahead.mp3'					
,'youhavereachedyourgoaldistancegreatjob.mp3'
,'youareaheadofyourtarget.mp3'				
,'youlookgreat.mp3'
,'youareaheadofyourtargetpace.mp3'			
,'youranked.mp3'
,'youarebehind.mp3'					
,'youraverageis.mp3'
,'youarebehindspeedup.mp3'				
,'yourgoal.mp3'
,'yourgoalisa.mp3'
,'youarehalfwaytothefinish.mp3'				
,'yourgoalisaheartrateof.mp3'
,'youarehalfwaytothefinishkeepgoing.mp3'		
,'yourgoalisapoweroutputof.mp3'
,'youareonequarterofthewaythereyoucandoit.mp3'		
,'yourgoalisaworkoutdistanceof.mp3'
,'youarerightontarget.mp3'				
,'yourgoalisaworkoutdurationof.mp3'
,'youarethreequartersofthewaytherealmostdone.mp3'	
,'yourgoalistoburn.mp3'
,'youaretoofast.mp3'					
,'yourgoalistomaintainapaceof.mp3'
,'youaretooslow.mp3'					
,'yourgoalistomaintainaspeedof.mp3'
,'youarewayaheadslowdown.mp3'				
,'yourgoalistomake.mp3'
,'youhavemetyourgoal.mp3'				
,'yourlaptimeis.mp3'
,'youhavereached.mp3'

        );

# check our list against existing files
# #####################################
print "\n--------- expected files -----------\n";
my $missingCount = 0;
my $okCount = 0;
my $i;
my $testfile;

for $i (0 .. $#files) {
  $testfile = $voicedir."/".$voiceid."_".$files[$i];

  if (-e $testfile) {
     # print 'File '.$testfile.' exists.\n';
     $okCount++;
  }
  else {
     print "File ".$testfile." does not exist.\n";
     $missingCount++;
   }
}

print "------------------------------------\n";
print "$missingCount files missing - $okCount are ok.\n";
print "\n\n";

# check existing files against out list
# #####################################
print "\n--------- existing files -----------\n";
opendir(DIR,$voicedir);
my @content = readdir(DIR);
my $fileFound=0;
my $fileNotfound=0;
for $i (0.. $#content){
   my $daFile = $content[$i];
   if ($daFile =~ m#${voiceid}_#){
      $daFile =~ s/${voiceid}_//g;
      if (grep {$_ eq $daFile} @files){
         # print "file:".$daFile." - found.\n";
         $fileFound++;
      }
      else{  
         print "file:".$daFile." - not in list.\n";
         $fileNotfound++;
      }
   }
}

print "------------------------------------\n";
print "$fileNotfound files unnecessary - $fileFound are ok.\n";
print "\n\n";

if ($voicerename){
print "\n------- renaming files ($voiceid -> $voicerename) ---------\n";
my $okCount = 0;
my $newfile;

for $i (0 .. $#files) {
  $testfile = $voicedir."/".$voiceid."_".$files[$i];
  $newfile = $voicedir."/".$voicerename."_".$files[$i];
  rename($testfile,$newfile);
}

print "------------------------------------\n";
print "$okCount files renamed.\n";
print "\n\n";

}

sub usage{
  print "usage:\n";
  print "  voicecheck.pl -v <voice_id> [-d <sub directory>] [-r <new voice_id>]\n";
  print "          -v <voice_id>: use <voice_id> to search for voice files. default: 'laura'\n"; 
  print "          -d <sub directory>: searches for files in that subdirectory\n";
  print "          -r <new vioce_id>: renames all voice files to the new id\n";
  print "\n\n";
}
